<template>
  <div id="todo-form">
    <div class="vx-row p-5">
      <!-- Is Completed -->
      <div class="vx-col">
        <div
          v-if="value.completedDate && value.completedDate != ''"
          class="congrat-decord"
        >
          <div class="flex items-center">
            <feather-icon
              icon="CheckCircleIcon"
              svgClasses="h-12 w-12 text-success"
              class="mr-2"
            />
            <h5 class="text-success">Đã hoàn thành</h5>
          </div>
        </div>
        <vs-button
          v-else
          color="success"
          type="border"
          icon-pack="feather"
          icon="icon-check-square"
          @click.prevent="checkIsCompleted"
        >
          Hoàn thành
        </vs-button>
      </div>
      <!-- /Is Completed -->

      <div class="vx-col ml-auto flex">
        <!-- Is Important -->
        <feather-icon
          icon="InfoIcon"
          class="cursor-pointer"
          :svgClasses="[
            { 'text-success stroke-current': value.isImportant },
            'w-8',
            'h-8 mr-4'
          ]"
          @click.prevent="updateData('isImportant', !value.isImportant)"
        />
        <!-- /Is Important -->

        <!-- Is Starred -->
        <feather-icon
          icon="StarIcon"
          class="cursor-pointer"
          :svgClasses="[
            { 'text-warning stroke-current': value.isStarred },
            'w-8',
            'h-8 mr-4'
          ]"
          @click.prevent="updateData('isStarred', !value.isStarred)"
        />
        <!-- /Is Starred -->

        <!-- Priority -->
        <vs-dropdown class="cursor-pointer" vs-custom-content>
          <feather-icon
            icon="FlagIcon"
            svgClasses="h-8 w-8 mr-4"
            @click.prevent
            :style="{ color: priorityColor(value) }"
          ></feather-icon>

          <vs-dropdown-menu style="z-index: 200001; width: 220px !important;">
            <vs-dropdown-item
              v-for="(priority, index) in priority_choices"
              :key="index"
            >
              <div
                @click.prevent="updateData('priority', priority.id)"
                :class="[
                  `cursor-pointer p-2 rounded`,
                  { 'font-semibold': value.priority == priority.id }
                ]"
              >
                <div class="flex">
                  <div
                    v-if="priority.textIcon"
                    class="mr-4 font-bold h5"
                    :style="{ color: labelColor(priority) }"
                  >
                    {{ priority.icon }}
                  </div>
                  <feather-icon
                    v-else
                    icon="FlagIcon"
                    svgClasses="h-4 w-4 mr-4"
                  />
                  {{ priority.label }}
                </div>
              </div>
            </vs-dropdown-item>
          </vs-dropdown-menu>
        </vs-dropdown>
        <!-- /Priority -->
      </div>
    </div>

    <vs-divider class="m-0 p-0" />

    <div class="modal-body p-0 mt-5">
      <form>
        <div class="w-full vx-row" style="margin: 0 0;">
          <div class="vx-col w-2/3">
            <!-- Name -->
            <vs-input
              v-validate="'required'"
              name="title"
              class="w-full mb-4 mt-5"
              label-placeholder="Tiêu đề"
              placeholder="Tiêu đề"
              v-model="value.name"
              @change="updateData('name', $event.target.value)"
              :color="isValid ? 'success' : 'danger'"
            />
            <!-- /Name -->

            <!-- Description -->
            <label class="vs-input--label">Mô tả</label>
            <vs-textarea
              class="mb-5"
              counter="120"
              maxlength="120"
              v-model="value.description"
              @change="updateData('description', $event.target.value)"
              rows="1"
            />
            <!-- /Description -->

            <!-- Checklist -->
            <CheckListForm
              v-model="value.checkList"
              @input="updateData('checkList', $event)"
            />
            <!-- /Checklist -->

            <!-- Attachments -->
            <div class="w-full mt-2">
              <BaseFileInput
                v-model="value.attachmentInfos"
                @input="updateData('attachmentInfos', $event)"
              />
            </div>
            <!-- /Attachments -->
          </div>

          <div
            class="vx-col p-0 w-1/3 border-l-2 border-b-2 border-t-0 border-r-0 border-solid d-theme-border-grey-light bg_grey"
            style="border-bottom-left-radius: 10px;"
          >
            <!-- Due Date and Start Date -->
            <DateSelectionDropdown
              :start="
                value.startDate && value.startDate != ''
                  ? new Date(value.startDate)
                  : null
              "
              :due="
                value.dueDate && value.dueDate != ''
                  ? new Date(value.dueDate)
                  : null
              "
              @input="updateData($event.field, $event.text)"
            />
            <!-- /Due Date and Start Date -->

            <vs-divider class="m-0 p-0" />

            <!-- Reminder -->
            <ReminderSelectionDropdown
              v-model="value.crontabSchedule"
              @input="updateData('crontabSchedule', $event)"
            />
            <!-- /Reminder -->

            <vs-divider class="m-0 p-0" />

            <TagSelectionDropdown
              v-model="value.labelIds"
              @input="updateData('labelIds', $event)"
            />

            <vs-divider class="m-0 p-0" />

            <ProjectSelectionDropdown
              v-model="value.projectId"
              @input="updateData('projectId', $event)"
            />

            <vs-divider class="m-0 p-0" />
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import _clone from "lodash/cloneDeep";
import { PriorityEnums } from "../../constants/enums";
import { convertSelectList } from "../../core/utils/list";
import { todoLabelColor, todoPriorityColor } from "../../core/utils/color";
import TagSelectionDropdown from "./components/TagSelectionDropdown.vue";
import ProjectSelectionDropdown from "./components/ProjectSelectionDropdown.vue";
import DateSelectionDropdown from "./components/DateSelectionDropdown.vue";
import ReminderSelectionDropdown from "./components/ReminderSelectionDropdown.vue";
import CheckListForm from "./components/CheckListForm.vue";
import BaseFileInput from "../../components/form-elements/BaseFileInput.vue";

import "flatpickr/dist/flatpickr.css";

export default {
  name: "todo-form",
  components: {
    TagSelectionDropdown,
    ProjectSelectionDropdown,
    DateSelectionDropdown,
    ReminderSelectionDropdown,
    CheckListForm,
    BaseFileInput
  },
  props: {
    value: { type: Object, default: () => ({}) }
    // isValid: { type: Boolean, default: true }
  },
  data() {
    return {
      isValid: true
    };
  },
  computed: {
    taskProjects() {
      return this.$store.state.todo.taskProjects;
    },
    priority_choices() {
      return convertSelectList(PriorityEnums);
      // const priorityColors = ["danger", "warning", "primary", "grey", "danger"];
      // return convertSelectList(PriorityEnums).map((priority, index) => ({
      //   ...priority,
      //   color: priorityColors[index]
      // }));
    },
    // validateForm() {
    //   return !this.errors.any() && this.value.title != "";
    // },
    labelColor() {
      return priority => {
        return todoLabelColor(priority.color).color;
      };
    },
    taskStatus() {
      return task => {
        if (!task.isCompleted && !task.isTrashed) return "Đang mở";
        else if (task.isCompleted && !task.isTrashed) return "Đã đóng";
        return "Đã lưu trữ";
      };
    },
    priorityColor() {
      return task => {
        const code = todoPriorityColor(task.priority).color;
        return todoLabelColor(code).color;
      };
    }
  },
  watch: {
    value(val) {
      if (
        val.completedDate &&
        val.completedDate != "" &&
        val.isCompleted == false
      ) {
        this.updateData("isCompleted", true);
      }
    }
  },
  methods: {
    updateData(field, text) {
      console.log("[TODO_FORM]", field, text);
      const newData = { ...this.value, [field]: text };
      this.$emit("input", newData);
    },

    checkIsCompleted() {
      this.updateData("completedDate", new Date().toISOString());
      // this.updateData("isCompleted", true);
    }
  }
};
</script>

<style lang="scss">
#todo-form {
  .scroll-container {
    background-color: rgba(252, 219, 206, 0.2);
  }
  .bg_grey {
    background-color: rgba(247, 249, 250, 1);
  }
  .bg_light_primary {
    background-color: rgb(159, 151, 252);
  }
  .img-upload {
    width: 100px;
    height: 100px;
    margin: 9px;
  }
  .btn-x-file {
    position: absolute;
    top: 5px;
    padding: 0;
    right: 0.8em;
    top: 0.8em;
    color: white;
    background: rgba(83, 83, 83, 0.6);
    z-index: 52007;
    // opacity: 0;
    border: 0;
    cursor: pointer;
    border-radius: 10px;
    &:hover {
      background: rgba(255, 47, 47, 0.6);
      transition: all 0.2s ease;
      transform: translate(20%, -20%);
    }
  }
  .con-img-upload {
    .con-input-upload,
    .img-upload {
      width: 100px;
      height: 100px;
      margin: 9px;
    }
  }
}
.scroll-container {
  color: inherit;
  position: relative;
  padding-left: 0.7rem;
  padding-right: 0.7rem;
  font-size: 1rem;
  border-radius: 5px;
  border: 1px solid rgba(0, 0, 0, 0.2);
  box-shadow: 0 0 0 0 rgba(0, 0, 0, 0.15);
  transition: all 0.3s ease;
  width: 100%;
}
.checklist-container {
  height: 125px;
}
</style>
